"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var TickXsWhiteIcon_1 = __importDefault(require("@alfalab/icons-classic/TickXsWhiteIcon"));
var CheckIndeterminateSWhiteIcon_1 = __importDefault(require("@alfalab/icons-classic/CheckIndeterminateSWhiteIcon"));
var index_module_css_1 = __importDefault(require("./index.module.css"));
exports.Checkbox = react_1.forwardRef(function (_a, ref) {
    var _b;
    var checked = _a.checked, label = _a.label, hint = _a.hint, onChange = _a.onChange, className = _a.className, name = _a.name, disabled = _a.disabled, dataTestId = _a.dataTestId, _c = _a.indeterminate, indeterminate = _c === void 0 ? false : _c, restProps = __rest(_a, ["checked", "label", "hint", "onChange", "className", "name", "disabled", "dataTestId", "indeterminate"]);
    var handleChange = function (event) {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name: name });
        }
    };
    return (
    // eslint-disable-next-line jsx-a11y/label-has-associated-control
    react_1.default.createElement("label", { className: classnames_1.default(index_module_css_1.default.component, className, (_b = {},
            _b[index_module_css_1.default.disabled] = disabled,
            _b[index_module_css_1.default.checked] = checked,
            _b[index_module_css_1.default.indeterminate] = indeterminate,
            _b)), ref: ref },
        react_1.default.createElement("span", { className: index_module_css_1.default.box },
            react_1.default.createElement("input", __assign({ type: 'checkbox', onChange: handleChange, disabled: disabled, checked: checked, "data-test-id": dataTestId }, restProps)),
            checked && react_1.default.createElement(TickXsWhiteIcon_1.default, null),
            indeterminate && !checked && (react_1.default.createElement(CheckIndeterminateSWhiteIcon_1.default, { className: index_module_css_1.default.indeterminateIcon }))),
        (label || hint) && (react_1.default.createElement("span", { className: index_module_css_1.default.content },
            label && react_1.default.createElement("span", { className: index_module_css_1.default.label }, label),
            hint && react_1.default.createElement("span", { className: index_module_css_1.default.hint }, hint)))));
});
